/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PerfilFuncionDAO;
import com.rjconsultores.ventaboletos.entidad.PerfilFuncion;
import com.rjconsultores.ventaboletos.service.PerfilFuncionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author rodrigo
 */
@Service("perfilFuncionService")
public class PerfilFuncionServiceImpl implements PerfilFuncionService {

    @Autowired
    private PerfilFuncionDAO perfilFuncionDAO;

    public List<PerfilFuncion> obtenerTodos() {
        return perfilFuncionDAO.obtenerTodos();
    }

    public PerfilFuncion obtenerID(Integer id) {
        return perfilFuncionDAO.obtenerID(id);
    }

    @Transactional
    public PerfilFuncion suscribir(PerfilFuncion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return perfilFuncionDAO.suscribir(entidad);
    }

    @Transactional
    public PerfilFuncion actualizacion(PerfilFuncion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return perfilFuncionDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PerfilFuncion entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        perfilFuncionDAO.actualizacion(entidad);
    }

	@Override
	public boolean usuarioPossuiPermissaoFuncionalidade(Integer usuarioId, String descRuta) {
		return perfilFuncionDAO.usuarioPossuiPermissaoFuncionalidade(usuarioId, descRuta);
	}
}
